import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:yao_core/src/mixin/request.dart';

import '../yao_core.dart';
import 'manager/middleware.dart';
import 'mixin/app.dart';
import 'widget/error_retrier.dart';

abstract class YaoService<T> extends GetxService with AppMixin {
  Future<T> run();
}

class YaoView<T> extends StatelessWidget with AppMixin {
  const YaoView({Key? key}) : super(key: key);

  final String? tag = null;

  T get c => GetInstance().find<YaoController>(tag: tag) as T;

  @override
  Widget build(BuildContext context) {
    throw UnimplementedError();
  }

  Widget withState(BuildContext context,
      {required Widget Function(dynamic state) child}) {
    YaoControllerWithState tmp = c as YaoControllerWithState;
    return tmp.obx((state) => child(state),
        onLoading: Builder(
          builder: (BuildContext context) {
            return Center(child: CircularProgressIndicator());
          },
        ),
        onError: (err) => MaterialApp(
            debugShowCheckedModeBanner: false,
            home: Scaffold(
                body: SafeArea(
                    child: (ErrorRetrier(err == null ? "" : err, () async {
              // final request = Get.find<Request>();
              Get.offNamed(Get.currentRoute, preventDuplicates: false);
            }))))));
  }
}

abstract class YaoController extends GetxController
    with AppMixin, RequestMixin {}

abstract class YaoControllerWithState<T> extends YaoController
    with StateMixin<T> {}

abstract class YaoControllerCustom extends GetxController
    with AppMixin, RequestMixin {}
